# ****************************************************************************
# Surgeweb Addressbook autocompletion, taken directly from webmail implementation. 
#  and sourcing data from surgeplus!!
# Needs to be tidied up and redundant functions etc removed for surgeweb implementation.
# BUT it seems to work fine without any changes so that is real nice!!
# ****************************************************************************



// Autocomplete implementation for webmail and wmail
// Author: Marijn Weehuizen		Dec 2006


#QQ// In memory addressbook data structure
#QQ	var address_book;

// Data pertaning to currently active autocompletion
var autocomplete;

var init_autocomplete=ac_pageload;

var use_cache=false;
var use_shortlist=false;
var cache_array=[];

ac_scriptload();

// ----------------------------
// -- Initialisation --
// ----------------------------
function ac_scriptload(){
	address_book = new Object;
	autocomplete = new Object;
	cache_array[1]= new Object; // cache;	// autocomplete cache
}
function ac_pageload(){
	var x;
	x=dge('to_field'); 
	if (x) ac_register_ctl(x, "default source");	
	x=dge('cc_field');
	if (x) ac_register_ctl(x, "default source");	
	x=dge('bcc_field') 
	if (x) ac_register_ctl(x, "default source");	
	if(!address_book.data){
		// invalid check as it matches empty address book. dogh!
		//download_addressbook();
	}
	autocomplete.selected=0;
}
function ac_register_ctl(ctl,src){
	add_event(ctl,'keydown',ac_keydown);
	add_event(ctl,'blur',ac_blur);
	add_event(ctl,'focus',ac_focus);
}
function download_addressbook()
{
	alert("starting background abk download (unimplemented)");
}

// ----------------------------
// -- Autocompletion event handling --
// ----------------------------

function ac_keydown(e) {
	if (!e) var e=window.event;
	generalise_event_info(e);
	var defaults=true;
	switch(e.keyCode)
	{
		case 188: // COMMA
		case 186: // SEMICOLON
			if (e.shiftKey){
				ac_defaultkey(e)
				break;			
			}
			// drop trhough to tab
		case 9: // 9=TAB 
			if (ac_docomplete(e))
				defaults=false;
			break;
		case 13: // 13=ENTER
			if (!ac_docomplete(e)){
				focus_next_surgeweb_edit_ctl(target(e));
			}
#			stopEvent(e);
			defaults=false;
			break;
		case 27:				// ESC
			ac_escape(e);
			defaults=false;
			break;
		case 38:case 40:		// 38=uparrow 40=downarrow
			ac_arrowkey(e)
			break;
		case 37:case 39:		// 37=leftarrow 40=rightarrow
		default:
			ac_defaultkey(e)
			break;
	}
	if (!defaults) stopEvent(e);
	return defaults;
}
function ac_blur(e) { 
	ac_hide(autocomplete); 
}
function ac_focus(e) { 
	if (!e) var e=window.event;
	generalise_event_info(e);
	ac_defaultkey(e); 
}

function ac_dd_mousemove(e) {
	if (!e) var e=window.event;
	generalise_event_info2(e);
	var x=se(e);
	if (x.id.indexOf('i_')!=0) return;
	var ac=autocomplete;
	ac.selected=x.id.substr(2);
	ac_show(ac.ctl,ac);
}
function ac_dd_mouseup(e) {
	if (!e) var e=window.event;
	generalise_event_info2(e);
	var x=se(e);
	if (x.id.indexOf('i_')!=0) return;
	var ac=autocomplete;
	ac.selected=x.id.substr(2);
	ret=ac_complete(ac.ctl,ac,',',true);
	focus_ctl=ac.ctl;
	setTimeout('return_focus();',10);
}
function ac_dd_focus(e) {
	if (!e) var e=window.event;
	generalise_event_info2(e);
	var x=se(e);
	if (x.id.indexOf('ac')!=0) return;
	var ac=autocomplete;
	ac.cancelhide=true;
}
function ac_dd_blur(e) {
	if (!e) var e=window.event;
	generalise_event_info2(e);
	var x=se(e);
	if (x.id.indexOf('ac')!=0) return;
	var ac=autocomplete;
	ac_hide(ac);
}

var focus_ctl;
function return_focus(){
	var oldpos=cursor_position(focus_ctl);
	setCaretPosition(focus_ctl,oldpos>0?oldpos:9999);
}

var ac_timer;
// -- Core autocomplete functionality --
function ac_defaultkey(e){
	// run main ac trough timer to catch multiple keys and provide us access to
	// text area contents
	if (ac_timer) clearTimeout(ac_timer);
	ac_timer=setTimeout('ac_defaultkey_delayed("'+e.target.id+'")',200);
	autocomplete.ctl=e.target;
}
function ac_defaultkey_delayed(id){
	ac_timer=null;
	var ac=autocomplete;
	var textarea=dge(id);
	if (textarea.value.length==0) return ac_hide(ac);
	var posn=cursor_position(textarea);
	if(posn==0) return ac_hide(ac);
	var txt=relevantText(textarea.value,posn);
	if(txt.length==0) return ac_hide(ac);
	var entries;
	if(sw.is_popup)
		entries=sw_win.ac_lookup_string(txt, sw_win.address_book, ac);
	else
		entries=ac_lookup_string(txt, address_book, ac);
	if (entries==0) return ac_hide(ac);
	
	ac_show(textarea,ac);
}
// -- Additional autocomplete functionality --
function ac_arrowkey(e){
	var new_selected = autocomplete.selected + (e.keyCode==38?-1:+1);
	if (new_selected<0 || new_selected>autocomplete.displayed_length)
		return;
	autocomplete.selected=new_selected;
	ac_show(e.target,autocomplete);
}

function ac_escape(e){
	var ac=autocomplete;
	ac_hide(ac);
}

function ac_docomplete(e){
	var ac=autocomplete;
	ret=ac_complete(e.target,ac,',');
	ac_hide(ac);
	if (ret){
		focus_ctl=ac.ctl;
		setTimeout('return_focus();',10);
	}
	return ret;
}


// ----------------------------
// --- Addressbook lookup ---
// ----------------------------

// --- lookup autocomplete data (optionally cached, retrieve data on demand?) ---
function ac_lookup_string(lookup_text,abk,ac)
{
	if (!abk.data) return 0;
    lookup_text=lookup_text.toLowerCase();
    var e=split_address(lookup_text);
    var name=e[0], email=e[1];
    if(!name&&!email) return 0;
    var ret=[];
    ret.name=name; ret.email=email;
	if(!use_cache){
		ret.match=abk_match_addresses(abk,ret.name,ret.email);
	}else{
		var mycache=cache_array[1];
		var q=mycache.find(lookup_text);
		if(l){
			ret.match=q;
		}else{
			for(var i=lookup_text.length-1;i>0;i--){
				var n=lookup_text.substr(0,i);
				q=mycache.find(n);
				if(q) break;
			}
			var db=(q!=null)?q:abk.data;
			ret.match=abk_match_addresses(db,ret.name,ret.email);
			mycache.add(lookup_text,result)
		}
	}
    ac.search=ret;
    return ret.match.length;
}

// --- autocomplete actual data comparison ---
function abk_match_addresses(db,qname,qemail)
{
	var ret=[];
	var data=db.data;
	var order=db.ac_order;
	for(var i=0;i<order.length;i++){
		var c=data[order[i]], match=false;
		// if(invalid for some reason) continue;

		var email=c_email(c).toLowerCase();
		if(qemail && email.indexOf(qemail)==0) match=true;

		var fullname=c_name(c).toLowerCase();
		var nickname=c.nick.toLowerCase();
		var company=c.company&&c.company.value?c.company.value.toLowerCase():'';
		if(qname){
			if(fullname && mystrstr(fullname,qname)>=0 ) match=true;
			if(use_shortlist&&nickname && mystrstr(nickname,qname)>=0 ) match=true;
			if(email.indexOf(qname)==0) match=true;
			if(company.indexOf(qname)==0) match=true;
		}
		if (match)
			ret[ret.length]=c;
	}
	return ret;
}

// --- Actual display of the appropriate autocomplete div ---
function ac_show(ctl,ac)
{
    var data=[];
    var mymatch=ac.search.match;
    var total_adr=mymatch.length;
	if (total_adr==0)
		return;
    if(ac.selected>=total_adr) 
    	ac.selected=total_adr-1;

    var txt,max_adr=7;
    for(var i=0;i<total_adr&&i<max_adr;i++){
        var c=mymatch[i];
		if (use_shortlist&&(c.nick!=c_email(c)) && c.shortlist)
        	txt=bold_substring(c.nick,ac.search.name);
        else
        	txt=format_entry(c,ac.search);
        var tmp1="";
        var tmp2="";
		if(i==ac.selected) tmp1=" sel";
		ac.displayed_length=i;
        data.push('<span style="'+tmp2+'" class="l'+tmp1+'" id="i_'+i+'">'+txt+"</span>");
    }
 	var dropdown=get_element("ac");    
 	if (!dropdown.ac_init){
		add_event(dropdown,'mousemove',ac_dd_mousemove);		
		add_event(dropdown,'mousedown',ac_dd_mouseup);		
		add_event(dropdown,'focus',ac_dd_focus);		
		add_event(dropdown,'blur',ac_dd_blur);		
 		dropdown.ac_init='true';
 	}
    dropdown.innerHTML=data.join('');
	pos_dropdown_by_ctl(dropdown,ctl)
	ac.active=true;
}

// --- do the autocompletion ---
function ac_complete(ctl,ac,sep,mouse) 
{
	var txt=ctl.value;
	var posn=cursor_position(ctl);
    if(!ac.active) return false;

	var new_address=ac_format_address(ac.search.match[ac.selected]);
	var cur=get_current_chunk(txt,posn,find_quoted_chunks(txt));
	var sep2="";
	if(cur[1]==txt.length || txt.charAt(cur[1])!="," && txt.charAt(cur[1])!=";")
		sep2=sep+" ";
	var new_txt=txt.substring(0,cur[0])+new_address+sep2+txt.substring(cur[1]);
	var new_posn=cur[0]+new_address.length+sep2.length;
	
	if (!ctl.edit_fancy){
		ctl_set(ctl,new_txt,new_posn);
	}else{
		var o=ctl.parentNode;
#		Bit of a hack as it has already been added once if tab/enter is pressed for fancy controls
#		possibly should implement in a nicer way at some stage
		if(!mouse) cl_remove_cb(o.previousSibling);
		var node=cl_add_contact(text2contact(new_address),o);
		ctl.value='';
	}
	return true;
}

// --------------------------------------
// -- Autocomplete supporting functionality ---

function relevantText(all_text,cursor_posn){
    var quoted_chunks=find_quoted_chunks(all_text);						// returns array of begin/end pairs
    var chunk=get_current_chunk(all_text,cursor_posn,quoted_chunks);
    var tmp=all_text.substring(chunk[0],chunk[1]);
    return tmp.replace(/\"/g,"")
}
function format_entry(c,srch){
    var name,email;
#    debugger;
    name=clean_whitespace(c_name(c));
    if(name!=''){
    	name=replace_quotes(name);
    	email=' <'+c_email(c)+'>';
    }else{
    	name='';
    	email=c_email(c);
    }
 
    return bold_substring(name,srch.name) + bold_substring(email,srch.email?srch.email:srch.name);
}
function bold_substring(a,b){
    if(b!=""){
        var c=mystrstr(a.toLowerCase(),b);
        if(c!=-1){
            return xencode(a.substr(0,c))+"<b>"+xencode(a.substr(c,b.length))+"</b>"+xencode(a.substr(c+b.length))
        }
    }
    return xencode(a)
}

function ac_hide(ac){
	ac.cancelhide=false;
	setTimeout('hide_now();',50);
}
function hide_now(){
	var ac=autocomplete;
	if(ac.cancelhide==true) return;
	ac.active=false;
	ac.selected=0;
	hide("ac");
}

function ac_format_address(c){
    var name=c_name(c);
    name=clean_whitespace(name);
    return(name!=''?name+' ':"")+"<"+c_email(c)+">";
}
function ctl_set(ctl,txt,posn){
    ctl.value=txt;
    ctl_set_cursor(ctl,posn);
}
function ctl_set_cursor(ctl,posn){
    if(def(ctl.selectionEnd)&&def(ctl.selectionStart)){
        ctl.selectionStart=posn;
        ctl.selectionEnd=posn
    } else if(document.selection&&ctl.createTextRange){
        var r=ctl.createTextRange();
        r.collapse(true);
        r.move("character",posn);
        r.select()
    }
}

// ---



